#!/usr/bin/env python

from os import listdir
import sys
import re
import os
from Cheetah.Template import Template

FIGTEX = """
\includegraphics[width=\columnwidth]{sched_results/$file}
\captionof*{figure}{$util_dist, $period, $task_util, $wss, $msz, $num_graphs}
\\vspace{0.2in}"""

# FIGTEXH = """
# \includegraphics[width=\columnwidth]{histos/$file}
# \captionof*{figure}{$util_dist, $period, $task_util, $wss}
# \\vspace{0.2in}"""

FIGS_PER_PAGE = 8

def main():
    parameters = ["util_dist",
                  "period",
                  "task_util",
                  "wss",
                  "msz",
                  "num_graphs"]
    dist_conv = {   'heavy-light-light':'A-Heavy', 
                    'light-heavy-light':'B-Heavy', 
                    'light-light-heavy':'C-Heavy', 
                    'medium-medium-light':'AB-Mod.',
                    'medium-light-medium':'AC-Mod.',
                    'light-medium-medium':'BC-Mod.',
                    'medium-medium-medium':'All-Mod.',
                    
                    'harmonic-short':'Short', 
                    'harmonic-contrast':'Cont.', 
                    'harmonic-long':'Long',
                    
                    'uni-heavy':'Heavy', #How to handle wss?
                    'uni-medium':'Mod.', 
                    'uni-light':'Light',
                    
                    'uni-small':'Small',
                    'uni-large':'Large'
                    }
                  
    outpdf = open("sched-app-plots.tex", 'w')
    filenamegroup = []
    for j, filenameiter in enumerate(os.listdir(os.getcwd() + "/../plots_online/")):
        filenamegroup.append(filenameiter)
        if len(filenamegroup) == 8 or j == 566:
            texgroupsched = []
            for filename in filenamegroup:
                splits = []
                splits.append(-2)
                for i in range(0, len(filename)-1):
                    if filename[i] + filename[i+1] == '--':
                        splits.append(i)
                namespace = dict()
        
                splits.append(len(filename)-4)
                for i in range(0, len(splits)-1):
                    namespace[parameters[i]] = filename[(splits[i]+2):splits[i+1]]
                
                namespace["util_dist"] = dist_conv[namespace["util_dist"]]
                namespace["task_util"] = dist_conv[namespace["task_util"]]
                namespace["period"] = dist_conv[namespace["period"]]
                namespace["wss"] = dist_conv[namespace["wss"]]
                namespace["msz"] = dist_conv[namespace["msz"]]
                namespace["num_graphs"] = dist_conv[namespace["num_graphs"]]
                namespace["file"] = filename
                
                texgroupsched.append(Template(FIGTEX, searchList = namespace))
            
            outpdf.write("\clearpage\n\\begin{minipage}{\\textwidth}\n\\centering\n")
            
            outpdf.write("\n\\begin{minipage}{0.45\\columnwidth}\n\\centering\n")
            for i in range(0,4):
                outpdf.write(str(texgroupsched[i]))
            outpdf.write("\n\\end{minipage}")
            outpdf.write("\\hspace{0.2in}")
            outpdf.write("\n\\begin{minipage}{0.45\\columnwidth}\n\\centering\n")
            for i in range(4,len(texgroupsched)):
                outpdf.write(str(texgroupsched[i]))
            outpdf.write("\n\\end{minipage}\n")
            
            outpdf.write("\n\\end{minipage}\n")
            filenamegroup = []
    outpdf.close()

if __name__ == '__main__':
    main()

