from schedcat.generator.tasks import uniform_int, uniform, exponential, multimodal, uniform_choice
import schedcat.generator.tasks as tasks
from schedcat.model.LLCLayout import *
import graph

def bypass_scheme():
    AB = area(0, 4)
    C = area(16, 16)
    return scheme([AB, AB, AB, AB], [AB, AB, AB, AB], C, 16, 16)

def default_scheme():
    AB = area(4, 4)
    C = area(8, 16)
    return scheme([AB, AB, AB, AB], [AB, AB, AB, AB], C, 16, 16)
    
def wba_fixed_scheme():
    AB = area(2, 16)
    C = area(8, 16)
    return scheme([AB, AB, AB, AB], [AB, AB, AB, AB], C, 16, 16)
    
def default_share_scheme():
    AB = area(8, 4)
    C = area(8, 16)
    return scheme([AB, AB, AB, AB], [AB, AB, AB, AB], C, 16, 16)    

def pedf_scheme():
    A = area(0, 0)
    B = area(16, 4)
    C = area(0, 0)
    return scheme([A, A, A, A], [B, B, B, B], C, 16, 16)
    
def uni_scheme():
    A = area(0, 0)
    B = area(16, 16)
    C = area(0, 0)
    return scheme([A, A, A, A], [B, B, B, B], C, 16, 16)
    
def c_iso_scheme():
    AB = area(4, 4)
    C = area(8, 4)
    return scheme([AB, AB, AB, AB], [AB, AB, AB, AB], C, 16, 16)

#50-70 to #80-100
#20-40 to #30-60
def AVG_PERCENT(bkgrnd_load, level):
    min1, min2, max1, max2 = (0, 0, 0, 0)
    if level is 'A' or level is 'B':
        min1, max1, min2, max2 = {0.5, 0.7, 0.8, 1.0}
    elif level is 'C':
        min1, max1, min2, max2 = {0.2, 0.4, 0.3, 0.6}
    else:
        print "\n error in distributions, line 30 \n"
    
    bary = min(1.0, bkgrnd_load/4.0)
    
    tskmin = min1 + bary*(min2-min1)
    tskmax = max1 + bary*(max2-max1)
    
    return uniform(tskmin, tskmax)()

unmanwt = uniform(1.0, 1.3)
loadedinfAB = uniform(1.2, 1.5) 
loadedinfC = uniform(1.2, 1.5) 

CORES = 4

dlight = uniform(0.1, 0.3)
dmoder = uniform(0.35, 0.45)
dheavy = uniform(0.5, 0.7)


NAMED_UTIL_DISTS = {
    'medium-medium-light'  : {'A' : dmoder, 'B' : dmoder, 'C' : dlight},
#     'light-light-heavy'    : {'A' : dlight, 'B' : dlight, 'C' : dheavy},
#     'medium-medium-medium' : {'A' : dmoder, 'B' : dmoder, 'C' : dmoder}
}

NAMED_PERIODS = {
    'harmonic-short'       : {'A' : uniform_choice([3000, 6000]), 'B' : uniform_choice([6000, 12000]), 'C' : uniform_int( 3000,  33000)},
    'harmonic-medium'      : {'A' : uniform_choice([12000, 24000]), 'B' : uniform_choice([24000, 48000]), 'C' : uniform_int(12000,  100000)},
    'harmonic-long'        : {'A' : uniform_choice([48000, 96000]), 'B' : uniform_choice([96000, 192000]), 'C' : uniform_int(50000, 500000)},
}

NAMED_UTILIZATIONS = {
    'uni-light'     : {'A' : uniform(0.001, 0.03), 'B' : uniform(0.001, 0.05), 'C' : uniform(0.001, 0.1)},
    'uni-medium'    : {'A' : uniform( 0.02, 0.1), 'B' : uniform( 0.05, 0.2), 'C' : uniform(  0.1, 0.4)},
    'uni-heavy'     : {'A' : uniform(  0.1, 0.2), 'B' : uniform( 0.2, 0.4), 'C' : uniform(  0.4, 0.6)},
}

NAMED_MEMORY = {
    'uni-light'           : uniform(0.01, 0.1),
    'uni-heavy'           : uniform(0.25, 0.5),
}

NAMED_MEM_FOOTPRINTS = {
    'uni-light'     : {'A' : uniform(150, 300), 'B' : uniform(150, 300), 'C' : multimodal([(uniform(200, 700), 3), (uniform(600, 1300), 1)])},
    'uni-medium'    : {'A' : uniform(300, 500), 'B' : uniform(300, 500), 'C' : multimodal([(uniform(400, 900), 3), (uniform(1000, 3000), 1)])},
    'uni-heavy'     : {'A' : uniform(500, 700), 'B' : uniform(500, 700), 'C' : multimodal([(uniform(600, 1100), 3), (uniform(1300, 7500), 1)])},
}

light_sens = uniform(0.1, .3)
NAMED_PET_SENS = {
    'regular'         : {'way' : uniform(1.0, 1.0), 'color' : uniform(1.0, 1.0)},
    'way-heavy'       : {'way' : uniform(1.0, 1.0), 'color' : light_sens},
}

NAMED_MODE_COUNT = {
    'uni-small'   : graph.uniform(2,7),
    'uni-large'   : graph.uniform(8,12),
}

#percent of tasks shared between two consecutively generated modes
NAMED_MODE_OVERLAP = {
    'uni-light'          : uniform(0.0, 0.2),
    'uni-heavy'           : uniform(0.5, 0.7),
}

# percent of working sets that belongs to relevant state
NAMED_STATE_SIZE = {
    'fixed'     : {'A' : uniform(0.0, 0.10), 'B' : uniform(0.0, 0.10), 'C' : uniform(0.0, 0.10)},
}

#percent of shared tasks that change criticality between B and C
NAMED_CRIT_CHANGE = {
    'fixed'          : uniform(0.0, 0.2),
}

#percent variation in mode utilizations
NAMED_UTIL_VAR = {
    'fixed'          : uniform(-0.5, 0.5)
}

class Custom:
    pass

PAB = Custom()
PAB.ks = uniform(0.01, 0.05)
PAB.kw = uniform(0.01, 0.02)
PAB.kp = uniform(0.025, 0.75)
PAB.kmin = uniform(0.4, 0.8)

PAC = Custom()
PAC.ks = uniform(0.005, 0.03)
PAC.kw = uniform(0.01, 0.02)
PAC.kp = uniform(0.025, 0.75)
PAC.kmin = uniform(0.4, 0.8)

P = {
    'A': {'A': PAB},
    'B': {'A': PAB},
    'C': {'A': PAC}
}

redfunc = uniform(0, 0.05)